
// BeauGauge MFC Linear ExampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "BeauGauge MFC Linear Example.h"
#include "BeauGauge MFC Linear ExampleDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CBeauGaugeMFCLinearExampleDlg dialog




CBeauGaugeMFCLinearExampleDlg::CBeauGaugeMFCLinearExampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBeauGaugeMFCLinearExampleDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBeauGaugeMFCLinearExampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_STATIC_WEB, m_linkWeb);
	DDX_Control(pDX, IDC_STATIC_SUPPORT, m_linkSupport);

	for(int i = 0 ; i < 10 ; i++)
	{
		DDX_Control(pDX, IDC_BGV2ACTIVEXCTRL1+i, m_gauge[i]);
	}
}

BEGIN_MESSAGE_MAP(CBeauGaugeMFCLinearExampleDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// CBeauGaugeMFCLinearExampleDlg message handlers

BOOL CBeauGaugeMFCLinearExampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	m_linkWeb.SetURL(_T("http://www.beaugauge.com"),_T("www.beaugauge.com"));
	m_linkSupport.SetURL(_T("mailto:beaugauge@gmail.com"),_T("beaugauge@gmail.com"));

	m_random[0].SetAtom(0.4f);
	m_random[0].SetMinMax(0,100);

	m_random[1].SetAtom(0.1f);
	m_random[1].SetMinMax(0,100);

	m_random[2].SetAtom(0.6f);
	m_random[2].SetMinMax(0,100);

	this->SetTimer(1,1,NULL);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CBeauGaugeMFCLinearExampleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CBeauGaugeMFCLinearExampleDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBeauGaugeMFCLinearExampleDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CBeauGaugeMFCLinearExampleDlg::OnDestroy() 
{
	this->KillTimer(1);

	CDialog::OnDestroy();	
}

void CBeauGaugeMFCLinearExampleDlg::OnTimer(UINT nIDEvent) 
{
	if(1 == nIDEvent)
	{
		double f1 = m_random[0].GetSingle();
		double f2 = m_random[1].GetSingle();
		double f3 = m_random[2].GetSingle();

		int i = 0;
		m_gauge[i++].SetValue(_T("Needle1"),f1);
		m_gauge[i++].SetValue(_T("Needle1"),f2);
		m_gauge[i++].SetValue(_T("Needle1"),f3);
		m_gauge[i++].SetValue(_T("Needle1"),f2);
		m_gauge[i++].SetValue(_T("Needle1"),f3);
		m_gauge[i++].SetValue(_T("Needle1"),f1);
		m_gauge[i++].SetValue(_T("Needle1"),f2);
		m_gauge[i++].SetValue(_T("Needle1"),f3);
		m_gauge[i++].SetValue(_T("Needle1"),f1);
		m_gauge[9].SetValue(_T("Needle1"),f1);
		m_gauge[9].SetValue(_T("NumericIndicator1"),f1);
		//m_gauge1.SetValue(_T("Needle1"),m_random[0].GetSingle());
		//m_gauge2.SetValue(_T("Needle1"),m_random[2].GetSingle());
		//m_gauge2.SetValue(_T("Needle2"),m_random[1].GetSingle());
		//m_gauge3.SetValue(_T("Needle1"),m_random[1].GetSingle());
	}

	
	CDialog::OnTimer(nIDEvent);
}
